## libchewing 0.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8)
project(libchewing)

# Update configure.ac if LIBCHEWING_VERSION is changed.
set(LIBCHEWING_VERSION 0.5.1)
set(PACKAGE_VERSION ${LIBCHEWING_VERSION})
# Update configure.ac if LIBCHEWING_BINARY_VERSION is changed.
set(LIBCHEWING_BINARY_VERSION 1.0.0)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

if(UNIX)
    set(CMAKE_C_FLAGS "-g -O2 -Wall -fPIC ${CMAKE_C_FLAGS}")
    add_definitions(-DUNDER_POSIX -DPIC)
endif()

include(CheckCCompilerFlag)

if(${CMAKE_C_COMPILER_ID} STREQUAL "GNU" OR
    ${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
    set(CMAKE_C_FLAGS "-std=gnu99 ${CMAKE_C_FLAGS}")
    add_definitions(-D_GNU_SOURCE)
    option(ENABLE_GCOV "Coverage support" false)
    if(ENABLE_GCOV)
        set(CMAKE_C_FLAGS "-coverage ${CMAKE_C_FLAGS}")
    endif()

    # Use NO_UNDEFINED=no when running with address sanitizer
    option(NO_UNDEFINED "No undefined symbol in object file" true)
    if(NO_UNDEFINED)
        set(saved_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
        set(CMAKE_REQUIRED_FLAGS "-Wl,--no-undefined")
        check_c_compiler_flag("" HAVE_NO_UNDEFINED)
        set(CMAKE_REQUIRED_FLAGS ${saved_CMAKE_REQUIRED_FLAGS})

        if(HAVE_NO_UNDEFINED)
            set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--no-undefined ${CMAKE_SHARED_LINKER_FLAGS}")
        endif()
    endif()
elseif(CMAKE_C_COMPILER_ID MATCHES "MSVC")
    # XXX: Not sure why we need to use MATCHES instead of STREQUAL here.

    # /wd4819
    # Without BOM, Visual Studio does not treat source file as UTF-8
    # encoding, thus it will complain about invalid character. Use
    # /wd4819 can suppress this warning.
    set(CMAKE_C_FLAGS "/wd4819 ${CMAKE_C_FLAGS}")
    add_definitions(/D_CRT_SECURE_NO_WARNINGS /D_CRT_NONSTDC_NO_DEPRECATE)
    add_definitions(/D__func__=__FUNCTION__)

    # MSVC 2015 supports `snprintf`, so no need to redefine it
    if(MSVC_VERSION LESS 1900)
        add_definitions(/Dsnprintf=_snprintf)
    endif()

    option(BUILD_DLL "Build dynamic link library (*.dll) instead of static lib." false)
endif()

check_c_compiler_flag(-fvisibility=hidden FVISIBILITY_HIDDEN)
if(${FVISIBILITY_HIDDEN})
    set(CMAKE_C_FLAGS "-fvisibility=hidden ${CMAKE_C_FLAGS}")
endif()

# automake compatibility
add_definitions(-DHAVE_CONFIG_H=1)
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

option(WITH_SQLITE3 "Use sqlite3 to store userphrase" true)
option(WITH_INTERNAL_SQLITE3 "Use internal sqlite3" false)
if(MSVC)
    set(WITH_INTERNAL_SQLITE3 true)
endif()

# Use valgrind when testing
option(USE_VALGRIND "Use valgrind when testing" true)

# Feature probe
include(CheckTypeSize)
check_type_size(uint16_t UINT16_T)

set(CURSES_NEED_WIDE true)
find_package(Curses)

if (WITH_SQLITE3)
    if (WITH_INTERNAL_SQLITE3)
        set(SQLITE3_SRC_DIR ${PROJECT_SOURCE_DIR}/thirdparty/sqlite-amalgamation)
        include_directories(
            ${SQLITE3_SRC_DIR}
        )
    else()
        find_library(SQLITE3_LIBRARY sqlite3)
        find_file(SQLITE3_HEADER sqlite3.h)
        get_filename_component(SQLITE3_INCLUDE ${SQLITE3_HEADER} PATH)

        if (NOT (SQLITE3_LIBRARY AND SQLITE3_INCLUDE))
            message(SEND_ERROR "Cannot find sqlite3 library")
        endif()

        include_directories(SQLITE3_INCLUDE)
    endif()
endif()

include(CheckFunctionExists)
check_function_exists(strtok_r HAVE_STRTOK_R)
check_function_exists(asprintf HAVE_ASPRINTF)

include(CheckIncludeFiles)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(stdint.h HAVE_STDINT_H)

include(TestBigEndian)
test_big_endian(WORDS_BIGENDIAN)

set(SRC_DIR ${PROJECT_SOURCE_DIR}/src)
set(INC_DIR ${PROJECT_SOURCE_DIR}/include)
set(TOOLS_SRC_DIR ${PROJECT_SOURCE_DIR}/src/tools)
set(TOOLS_BIN_DIR ${PROJECT_BINARY_DIR}/src/tools)
set(DATA_SRC_DIR ${PROJECT_SOURCE_DIR}/data)
set(DATA_BIN_DIR ${PROJECT_BINARY_DIR}/data)
set(TEST_SRC_DIR ${PROJECT_SOURCE_DIR}/test)
set(TEST_BIN_DIR ${PROJECT_BINARY_DIR}/test)

include(GNUInstallDirs)

set(INFO_SRC ${PROJECT_SOURCE_DIR}/doc/libchewing.texi)
set(INFO_BIN ${PROJECT_BINARY_DIR}/doc/libchewing.info)

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/config.h.in
    ${PROJECT_BINARY_DIR}/include/config.h
)

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/version.texi.in
    ${PROJECT_BINARY_DIR}/doc/version.texi
)

set(prefix "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/lib")
set(includedir "\${prefix}/include")
set(datarootdir "\${prefix}/share")
set(datadir "\${datarootdir}")
set(sysconfdir "\${prefix}/etc")
configure_file(
    ${PROJECT_SOURCE_DIR}/chewing.pc.in
    ${PROJECT_BINARY_DIR}/chewing.pc
    @ONLY
)

include_directories(
    ${PROJECT_BINARY_DIR}/include
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/include/internal
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/src/porting_layer/include
)

set(ALL_DATA
    ${DATA_BIN_DIR}/dictionary.dat
    ${DATA_BIN_DIR}/index_tree.dat
)

set(ALL_INC
    ${INC_DIR}/chewing.h
    ${INC_DIR}/chewing-compat.h
    ${INC_DIR}/chewingio.h
    ${INC_DIR}/global.h
    ${INC_DIR}/mod_aux.h
)

# info page
find_program(MAKEINFO makeinfo)
if (MAKEINFO)
    add_custom_command(
        OUTPUT
            ${INFO_BIN}
        COMMAND ${MAKEINFO} ${INFO_SRC} -o ${INFO_BIN} -I ${PROJECT_BINARY_DIR}/doc
        DEPENDS
            ${INFO_SRC}
    )
    add_custom_target(INFO ALL DEPENDS ${INFO_BIN})
    add_dependencies(check INFO)

    find_program(INSTALL_INFO NAMES ginstall-info install-info)
    if (INSTALL_INFO)
        install(FILES ${INFO_BIN} DESTINATION ${CMAKE_INSTALL_INFODIR})
        install(CODE "execute_process(COMMAND ${INSTALL_INFO} --info-dir=${CMAKE_INSTALL_INFODIR} ${INFO_BIN})")
    endif()
endif()


# We need to copy static data to binary tree when using out of tree build.
set(ALL_STATIC_DATA
    ${DATA_BIN_DIR}/pinyin.tab
    ${DATA_BIN_DIR}/swkb.dat
    ${DATA_BIN_DIR}/symbols.dat
)

add_custom_target(all_static_data
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/pinyin.tab ${DATA_BIN_DIR}/pinyin.tab
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/swkb.dat ${DATA_BIN_DIR}/swkb.dat
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/symbols.dat ${DATA_BIN_DIR}/symbols.dat
)

set(ALL_STATIC_TEST stresstest.py)
foreach(target ${ALL_STATIC_TEST})
    add_custom_target(${target} ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${TEST_SRC_DIR}/${target} ${TEST_BIN_DIR}/${target}
    )
    add_dependencies(check ${target})
endforeach()

# tools
set(ALL_TOOLS init_database dump_database)
add_executable(init_database ${TOOLS_SRC_DIR}/init_database.c $<TARGET_OBJECTS:common>)
add_executable(dump_database
    ${TOOLS_SRC_DIR}/dump_database.c
    ${SRC_DIR}/porting_layer/src/plat_mmap_posix.c
    ${SRC_DIR}/porting_layer/src/plat_mmap_windows.c
    ${SRC_DIR}/porting_layer/src/rpl_malloc.c
    $<TARGET_OBJECTS:common>
)
set_target_properties(${ALL_TOOLS} PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${TOOLS_BIN_DIR}
        RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TOOLS_BIN_DIR}
        RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${TOOLS_BIN_DIR}
        RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TOOLS_BIN_DIR}
        RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${TOOLS_BIN_DIR}
)

# tools command
add_custom_command(
    OUTPUT
        ${ALL_DATA}
    COMMAND ${CMAKE_COMMAND} -E make_directory ${DATA_BIN_DIR}
    COMMAND ${CMAKE_COMMAND} -E chdir ${DATA_BIN_DIR} ${TOOLS_BIN_DIR}/init_database ${DATA_SRC_DIR}/phone.cin ${DATA_SRC_DIR}/tsi.src
    DEPENDS
        ${ALL_TOOLS}
        ${DATA_SRC_DIR}/phone.cin
        ${DATA_SRC_DIR}/tsi.src
)

# test
set(ALL_TESTCASES
    test-bopomofo
    test-config
    test-easy-symbol
    test-error-handling
    test-fullshape
    test-key2pho
    test-keyboard
    test-keyboardless
    test-logger
    test-mmap
    test-path
    test-regression
    test-reset
    test-special-symbol
    test-struct-size
    test-symbol
    test-userphrase
    test-utf8
)
set(ALL_TESTTOOLS
    performance
    randkeystroke
    simulate
    stress
    testchewing
)

if(${CURSES_FOUND})
    set(ALL_TESTTOOLS ${ALL_TESTTOOLS} genkeystroke)
endif()

enable_testing()

set(ALL_TESTS ${ALL_TESTCASES} ${ALL_TESTTOOLS})

foreach(target ${ALL_TESTCASES})
    add_test(${target} ${TEST_BIN_DIR}/${target})
endforeach()

if(USE_VALGRIND)
    find_program(VALGRIND valgrind)
    if(VALGRIND)
        foreach(target ${ALL_TESTCASES})
            add_test("valgrind-${target}" ${VALGRIND} --error-exitcode=255 --leak-check=full ${TEST_BIN_DIR}/${target})
        endforeach()
    endif()
endif()

foreach(target ${ALL_TESTS})
    add_executable(${target} ${TEST_SRC_DIR}/${target}.c)
    add_dependencies(${target} data all_static_data)
    add_dependencies(check ${target})
endforeach()

add_library(testhelper STATIC
    ${TEST_SRC_DIR}/testhelper.c
    $<TARGET_OBJECTS:chewing>
    $<TARGET_OBJECTS:common>
)
target_link_libraries(testhelper userphrase)
set_target_properties(testhelper PROPERTIES
    COMPILE_DEFINITIONS
        "CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\";TEST_HASH_DIR=\"${TEST_BIN_DIR}\";TEST_DATA_DIR=\"${TEST_SRC_DIR}/data\";TESTDATA=\"${TEST_SRC_DIR}/default-test.txt\""
)

set_target_properties(${ALL_TESTS} PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${TEST_BIN_DIR}
    COMPILE_DEFINITIONS
        "CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\";TEST_HASH_DIR=\"${TEST_BIN_DIR}\";TEST_DATA_DIR=\"${TEST_SRC_DIR}/data\""
)
foreach(target ${ALL_TESTS})
    target_link_libraries(${target} testhelper)
endforeach()

if (${CURSES_FOUND})
    target_link_libraries(genkeystroke ${CURSES_LIBRARIES})
endif()

# data
add_custom_target(data ALL DEPENDS ${ALL_DATA})

# library
add_library(chewing OBJECT
    ${ALL_INC}
    ${INC_DIR}/internal/chewing-private.h
    ${INC_DIR}/internal/chewingutil.h
    ${INC_DIR}/internal/choice-private.h
    ${INC_DIR}/internal/dict-private.h
    ${INC_DIR}/internal/global-private.h
    ${INC_DIR}/internal/pinyin-private.h
    ${INC_DIR}/internal/tree-private.h
    ${INC_DIR}/internal/userphrase-private.h
    ${INC_DIR}/internal/bopomofo-private.h

    ${SRC_DIR}/compat.c
    ${SRC_DIR}/chewingio.c
    ${SRC_DIR}/chewingutil.c
    ${SRC_DIR}/choice.c
    ${SRC_DIR}/dict.c
    ${SRC_DIR}/mod_aux.c
    ${SRC_DIR}/pinyin.c
    ${SRC_DIR}/porting_layer/include/plat_mmap.h
    ${SRC_DIR}/porting_layer/include/plat_path.h
    ${SRC_DIR}/porting_layer/include/plat_types.h
    ${SRC_DIR}/porting_layer/include/sys/plat_posix.h
    ${SRC_DIR}/porting_layer/include/sys/plat_windows.h
    ${SRC_DIR}/porting_layer/src/plat_mmap_posix.c
    ${SRC_DIR}/porting_layer/src/plat_mmap_windows.c
    ${SRC_DIR}/porting_layer/src/plat_path.c
    ${SRC_DIR}/porting_layer/src/rpl_malloc.c
    ${SRC_DIR}/private.h
    ${SRC_DIR}/tree.c
    ${SRC_DIR}/userphrase.c
    ${SRC_DIR}/bopomofo.c
)
set_target_properties(chewing PROPERTIES
    COMPILE_DEFINITIONS "CHEWING_DATADIR=\"${CMAKE_INSTALL_FULL_DATADIR}/libchewing\""
)

if (WITH_SQLITE3)
    add_library(userphrase STATIC
        ${INC_DIR}/internal/chewing-sql.h

        ${SRC_DIR}/chewing-sql.c
        ${SRC_DIR}/userphrase-sql.c
    )

    if (WITH_INTERNAL_SQLITE3)
        find_package (Threads)
        add_library(sqlite3_library STATIC
            ${SQLITE3_SRC_DIR}/sqlite3.c
            ${SQLITE3_SRC_DIR}/sqlite3.h
        )
        target_link_libraries(sqlite3_library ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})

        add_executable(sqlite3
            ${SQLITE3_SRC_DIR}/shell.c
        )
        target_link_libraries(sqlite3 sqlite3_library)
        set_target_properties(sqlite3 PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${SQLITE3_SRC_DIR}
            RUNTIME_OUTPUT_DIRECTORY_DEBUG ${SQLITE3_SRC_DIR}

=== debian/changelog ===
libchewing (0.5.1-5) unstable; urgency=medium

  [ Boyuan Yang ]
  * debian/: Apply wrap-and-sort -abst
  * debian/control: Bump debhelper compat to v13.
  * debian/control: Bump Standards-Version to 4.6.1.
  * debian/control: Use secure URI in homepage field.

  [ ChangZhuo Chen (陳昌倬) ]
  * Remove unused --fail-missing.
  * Update d/watch to version 4.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 28 Nov 2022 00:14:45 +0800

libchewing (0.5.1-4) unstable; urgency=medium

  * Team upload.
  * Rebuild against gcc 8.

  [ ChangZhuo Chen (陳昌倬) ]
  * debian/rules: Support nocheck
  * debian/changelog: Remove blank line in changelog
  * Add upstream metadata

  [ Boyuan Yang ]
  * debian: Apply "wrap-and-sort -abst".
  * debian/control:
    + Update YunQiang Su's email address and use the @debian.org one.
    + Refresh build dependency list
    + Bump Standards-Version to 4.2.1.
    + Update Vcs-* fields and use repo under input-method-team group.
    + Mark libchewing3-dev as M-A: same as suggested by M-A hinter.
  * debian/rules: Modernize packaging instructions and use
    dh_missing tool.

 -- Boyuan Yang <byang@debian.org>  Wed, 12 Sep 2018 21:37:34 -0400

libchewing (0.5.1-3) unstable; urgency=medium

  * Do not use parallel test since it is not supported by libchewing.
  * Use https in Format in debian/copyright.
  * Update Build-Depends for compat 11.
  * Remove unnecessary field Testsuite.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Fri, 22 Jun 2018 14:17:54 +0800

libchewing (0.5.1-2) unstable; urgency=medium

  * Bump Standards-Version to 4.1.4.
  * Bump compat to 11.
  * Update Vcs-* fields to salsa.
  * Update Maintainer to new mailing list.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 26 May 2018 09:58:41 +0800

libchewing (0.5.1-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 18 May 2016 19:35:42 +0800

libchewing (0.5.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 3.9.8.
  * Update Vcs-* fields.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 02 May 2016 11:39:04 +0800

libchewing (0.4.0-4) unstable; urgency=medium

  * Change XS-Testsuite to Testsuite.
  * Update Uploaders email.
  * Update Vcs-* fields.
  * Remove libchewing3-dbg in favor of dbgsym.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 20 Dec 2015 20:38:49 +0800

libchewing (0.4.0-3) unstable; urgency=medium

  * Fix compiler-flags-hidden

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Tue, 12 May 2015 21:15:31 +0800

=== debian/control ===
Source: libchewing
Section: libs
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Kan-Ru Chen (陳侃如) <koster@debian.org>,
 Andrew Lee (李健秋) <ajqlee@debian.org>,
 YunQiang Su <syq@debian.org>,
 ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libncurses-dev,
 libsqlite3-dev,
 pkg-config,
 texinfo,
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/input-method-team/libchewing
Vcs-Git: https://salsa.debian.org/input-method-team/libchewing.git
Homepage: https://chewing.im

Package: libchewing3
Architecture: any
Multi-Arch: same
Depends:
 libchewing3-data (>= 0.4.0),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Breaks:
 scim-chewing (<< 0.3.3),
Provides:
 libchewing,
Description: intelligent phonetic input method library
 libchewing is an intelligent phonetic input method library for Chinese.
 .
 It provides the core algorithm and logic so that they can be shared among
 the various input methods like JMCCE, xcin-chewing, scim-chewing,
 iiimf-chewing, screen-chewing, ime-chewing, etc.
 .
 The Chewing input method is a smart bopomofo fonetics input method that
 is useful for inputing Mandarin Chinese based language.
 .
 This package contains shared library used by other programs.

Package: libchewing3-data
Architecture: all
Multi-Arch: foreign
Section: misc
Depends:
 ${misc:Depends},
Breaks:
 libchewing-data (<= 0.2.7),
Provides:
 libchewing-data,
Description: intelligent phonetic input method library - data files
 libchewing is an intelligent phonetic input method library for Chinese.
 .
 It provides the core algorithm and logic so that they can be shared among
 the various input methods like JMCCE, xcin-chewing, scim-chewing,
 iiimf-chewing, screen-chewing, ime-chewing, etc.
 .
 The Chewing input method is a smart bopomofo fonetics input method that
 is useful for inputing Mandarin Chinese based language.
 .
 This package contains data files of libchewing3.

Package: libchewing3-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libchewing3 (= ${binary:Version}),
 ${misc:Depends},
Conflicts:
 libchewing-dev,
 libchewing1-dev,
 libchewing2-dev,
Description: intelligent phonetic input method library (developer version)
 libchewing is an intelligent phonetic input method library for Chinese.
 .
 It provides the core algorithm and logic so that they can be shared among
 the various input methods like JMCCE, xcin-chewing, scim-chewing,
 iiimf-chewing, screen-chewing, ime-chewing, etc.
 .
 The Chewing input method is a smart bopomofo fonetics input method that
 is useful for inputing Mandarin Chinese based language.
 .
 This package contains static library and header files for developer.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk

export V=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --includedir=/usr/include/$(DEB_HOST_MULTIARCH)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# libchewing does not support parallel test
	make check
endif

override_dh_missing:
	rm -f debian/*/usr/lib/*/*.la
	rm -f debian/*/usr/share/info/*.info

=== debian/watch ===
version=4

# See https://davesteele.github.io/development/2015/05/02/debian-watch-file-format-for-signed-github-source-tars/ for GitHub workaround for releases page.

opts="downloadurlmangle=s/archive\/refs\/tags\/v@ANY_VERSION@@ARCHIVE_EXT@/releases\/download\/v$1\/@PACKAGE@-$1\.tar\.bz2/,filenamemangle=s/v@ANY_VERSION@@ARCHIVE_EXT@/@PACKAGE@-$1\.tar\.bz2/" \
https://github.com/chewing/@PACKAGE@/tags .*/v@ANY_VERSION@@ARCHIVE_EXT@

## libchewing 0.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21.0)
project(libchewing)

set(CMAKE_PROJECT_VERSION 0.6.0)
set(LIBCHEWING_VERSION ${CMAKE_PROJECT_VERSION})
set(PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
set(LIBCHEWING_BINARY_VERSION 1.0.0)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

enable_testing()

if(UNIX)
    set(CMAKE_C_FLAGS "-g -O2 -Wall -fPIC ${CMAKE_C_FLAGS}")
    add_compile_definitions(UNDER_POSIX PIC)
endif()

include(CheckCCompilerFlag)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)

if(CMAKE_C_COMPILER_ID MATCHES GNU|Clang)
    set(CMAKE_C_FLAGS "-std=gnu99 ${CMAKE_C_FLAGS}")
    add_compile_definitions(_GNU_SOURCE)
    option(ENABLE_GCOV "Coverage support" false)
    if(ENABLE_GCOV)
        if(WITH_RUST AND CMAKE_C_COMPILER_ID MATCHES Clang)
            set(CMAKE_C_FLAGS "-fprofile-instr-generate -fcoverage-mapping ${CMAKE_C_FLAGS}")
        else()
            set(CMAKE_C_FLAGS "--coverage ${CMAKE_C_FLAGS}")
        endif()
    endif()

    # Use NO_UNDEFINED=no when running with address sanitizer
    option(NO_UNDEFINED "No undefined symbol in object file" true)
    if(NO_UNDEFINED)
        set(saved_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
        set(CMAKE_REQUIRED_FLAGS "-Wl,--no-undefined")
        check_c_compiler_flag("" HAVE_NO_UNDEFINED)
        set(CMAKE_REQUIRED_FLAGS ${saved_CMAKE_REQUIRED_FLAGS})

        if(HAVE_NO_UNDEFINED)
            set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--no-undefined ${CMAKE_SHARED_LINKER_FLAGS}")
        endif()
    endif()
elseif(MSVC)
    # /wd4819
    # Without BOM, Visual Studio does not treat source file as UTF-8
    # encoding, thus it will complain about invalid character. Use
    # /wd4819 can suppress this warning.
    set(CMAKE_C_FLAGS "/wd4819 ${CMAKE_C_FLAGS}")
    add_compile_definitions(_CRT_SECURE_NO_WARNINGS _CRT_NONSTDC_NO_DEPRECATE)
    add_compile_definitions(__func__=__FUNCTION__)

    # MSVC 2015 supports `snprintf`, so no need to redefine it
    if(MSVC_VERSION LESS 1900)
        add_compile_definitions(snprintf=_snprintf)
    endif()
endif()


check_c_compiler_flag(-fvisibility=hidden FVISIBILITY_HIDDEN)
if(${FVISIBILITY_HIDDEN})
    set(CMAKE_C_FLAGS "-fvisibility=hidden ${CMAKE_C_FLAGS}")
endif()

# automake compatibility
add_compile_definitions(HAVE_CONFIG_H=1)
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

option(WITH_SQLITE3 "Use sqlite3 to store userphrase" true)
option(WITH_INTERNAL_SQLITE3 "Use internal sqlite3" false)
if(MSVC)
    set(WITH_INTERNAL_SQLITE3 true)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Android")
    set(WITH_INTERNAL_SQLITE3 true)
endif()

# Use valgrind when testing
option(USE_VALGRIND "Use valgrind when testing" true)

option(WITH_RUST "Use rust implemented internals (experimental)" false)
if(WITH_RUST)
    include(FetchContent)
    FetchContent_Declare(
        Corrosion
        GIT_REPOSITORY https://github.com/corrosion-rs/corrosion.git
        GIT_TAG be76480232216a64f65e3b1d9794d68cbac6c690 # v0.4.5
    )
    FetchContent_MakeAvailable(Corrosion)

    corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing CRATE_TYPES staticlib FEATURES capi)
    corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing-tools)
    add_compile_definitions(WITH_RUST)
    if(CMAKE_BUILD_TYPE MATCHES Debug)
        corrosion_set_features(chewing FEATURES test-tracing)
    endif()
    if(WITH_SQLITE3)
        corrosion_set_features(chewing FEATURES sqlite)
    endif()
    corrosion_add_target_local_rustflags(chewing -Ccodegen-units=1)
    if(ENABLE_GCOV)
        corrosion_set_env_vars(chewing CARGO_INCREMENTAL=0)
        corrosion_add_target_local_rustflags(chewing -Cinstrument-coverage -Ccodegen-units=1 -Cinline-threshold=0 -Clink-dead-code -Coverflow-checks=off -Cpanic=abort)
    endif()
endif()

# Feature probe
include(CheckTypeSize)
check_type_size(uint16_t UINT16_T)

set(CURSES_NEED_WIDE true)
find_package(Curses)

if(WITH_SQLITE3)
    if(WITH_INTERNAL_SQLITE3)
        set(SQLITE3_SRC_DIR ${PROJECT_SOURCE_DIR}/thirdparty/sqlite-amalgamation)
        include_directories(
            ${SQLITE3_SRC_DIR}
        )
        find_package (Threads)
        add_library(sqlite3_library STATIC
            ${SQLITE3_SRC_DIR}/sqlite3.c
            ${SQLITE3_SRC_DIR}/sqlite3.h
        )
        target_link_libraries(sqlite3_library ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})

        add_executable(sqlite3
            ${SQLITE3_SRC_DIR}/shell.c
        )
        target_link_libraries(sqlite3 sqlite3_library)
        set_target_properties(sqlite3 PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY ${SQLITE3_SRC_DIR}
            RUNTIME_OUTPUT_DIRECTORY_DEBUG ${SQLITE3_SRC_DIR}
            RUNTIME_OUTPUT_DIRECTORY_RELEASE ${SQLITE3_SRC_DIR}
            RUNTIME_OUTPUT_DIRECTORY_RELEASE ${SQLITE3_SRC_DIR}
            RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${SQLITE3_SRC_DIR}
        )
        set(SQLite3_LIBRARIES sqlite3_library)
    else()
        find_package(SQLite3 REQUIRED)
        include_directories(SQLite3_INCLUDE_DIRS)
    endif()
endif()

include(CheckFunctionExists)
check_function_exists(strtok_r HAVE_STRTOK_R)
check_function_exists(asprintf HAVE_ASPRINTF)

include(CheckIncludeFiles)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(stdint.h HAVE_STDINT_H)

include(TestBigEndian)
test_big_endian(WORDS_BIGENDIAN)

set(SRC_DIR ${PROJECT_SOURCE_DIR}/src)
set(INC_DIR ${PROJECT_SOURCE_DIR}/include)
set(TOOLS_SRC_DIR ${PROJECT_SOURCE_DIR}/src/tools)
set(TOOLS_BIN_DIR ${PROJECT_BINARY_DIR}/src/tools)
set(DATA_SRC_DIR ${PROJECT_SOURCE_DIR}/data)
set(DATA_BIN_DIR ${PROJECT_BINARY_DIR}/data)
set(TEST_SRC_DIR ${PROJECT_SOURCE_DIR}/test)
set(TEST_BIN_DIR ${PROJECT_BINARY_DIR}/test)

include(GNUInstallDirs)

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/config.h.in
    ${PROJECT_BINARY_DIR}/include/config.h
)

configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/version.texi.in
    ${PROJECT_BINARY_DIR}/doc/version.texi
)

set(prefix "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/lib")
set(includedir "\${prefix}/include")
set(datarootdir "\${prefix}/share")
set(datadir "\${datarootdir}")
set(sysconfdir "\${prefix}/etc")
configure_file(
    ${PROJECT_SOURCE_DIR}/chewing.pc.in
    ${PROJECT_BINARY_DIR}/chewing.pc
    @ONLY
)

include_directories(
    ${PROJECT_BINARY_DIR}/include
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/include/internal
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/src/porting_layer/include
)

set(ALL_INC
    ${INC_DIR}/chewing.h
    ${INC_DIR}/chewing-compat.h
    ${INC_DIR}/chewingio.h
    ${INC_DIR}/global.h
    ${INC_DIR}/mod_aux.h
)

if(WITH_RUST)
    list(APPEND ALL_INC ${INC_DIR}/chewing_rs.h)
endif()

add_subdirectory(doc)
add_subdirectory(test)
add_subdirectory(data)

# library
add_library(common OBJECT
    src/porting_layer/src/asprintf.h

    src/porting_layer/src/asprintf.c
)
target_compile_definitions(common PRIVATE
    CHEWING_DATADIR=\"${CMAKE_INSTALL_FULL_DATADIR}/libchewing\"
)

add_library(libchewing ${ALL_INC} src/chewing.c)
set_target_properties(libchewing PROPERTIES LINKER_LANGUAGE C)
target_compile_definitions(libchewing PRIVATE
    CHEWING_DATADIR=\"${CMAKE_INSTALL_FULL_DATADIR}/libchewing\"
)
if(NOT WITH_RUST)
    target_sources(common PRIVATE
        ${SRC_DIR}/porting_layer/include/plat_mmap.h
        ${SRC_DIR}/porting_layer/include/plat_path.h
        ${SRC_DIR}/porting_layer/include/plat_types.h
        ${SRC_DIR}/porting_layer/include/sys/plat_posix.h
        ${SRC_DIR}/porting_layer/include/sys/plat_windows.h

        ${SRC_DIR}/porting_layer/src/plat_mmap_posix.c
        ${SRC_DIR}/porting_layer/src/plat_mmap_windows.c
        ${SRC_DIR}/porting_layer/src/plat_path.c
        ${SRC_DIR}/porting_layer/src/rpl_malloc.c
        ${SRC_DIR}/common/chewing-utf8-util.c
        ${SRC_DIR}/common/key2pho.c
    )
    target_sources(libchewing PRIVATE
        ${INC_DIR}/internal/bopomofo-private.h
        ${INC_DIR}/internal/chewing-private.h
        ${INC_DIR}/internal/chewingutil.h
        ${INC_DIR}/internal/choice-private.h
        ${INC_DIR}/internal/dict-private.h
        ${INC_DIR}/internal/global-private.h
        ${INC_DIR}/internal/pinyin-private.h
        ${INC_DIR}/internal/tree-private.h
        ${INC_DIR}/internal/userphrase-private.h

        ${SRC_DIR}/bopomofo.c
        ${SRC_DIR}/chewingio.c
        ${SRC_DIR}/chewingutil.c
        ${SRC_DIR}/choice.c
        ${SRC_DIR}/compat.c
        ${SRC_DIR}/dict.c
        ${SRC_DIR}/mod_aux.c
        ${SRC_DIR}/pinyin.c
        ${SRC_DIR}/private.h
        ${SRC_DIR}/tree.c
        ${SRC_DIR}/userphrase.c
    )
    if(WITH_SQLITE3)
        add_library(userphrase OBJECT
            ${INC_DIR}/internal/chewing-sql.h
            ${SRC_DIR}/chewing-sql.c
            ${SRC_DIR}/userphrase-sql.c
        )
    else()
        add_library(userphrase OBJECT
            ${INC_DIR}/internal/hash-private.h
            ${SRC_DIR}/hash.c
            ${SRC_DIR}/userphrase-hash.c
        )
    endif()
    target_link_libraries(libchewing
        PRIVATE common
        PRIVATE userphrase)
    if(BUILD_SHARED_LIBS AND MSVC)
        target_compile_definitions(libchewing PRIVATE CHEWINGDLL_EXPORTS)
    endif()
endif()

if(WITH_RUST)
    target_link_libraries(libchewing PRIVATE chewing)
    target_link_libraries(chewing INTERFACE ${SQLite3_LIBRARIES})
    if(BUILD_SHARED_LIBS)
        if(CMAKE_C_COMPILER_ID MATCHES GNU|^Clang)
            target_link_options(libchewing
                PRIVATE LINKER:-version-script,${CMAKE_SOURCE_DIR}/src/symbols-elf.map
                PRIVATE LINKER:--gc-sections
                PRIVATE LINKER:-u,chewing_new
                PRIVATE LINKER:-u,ueStrLen
                PRIVATE LINKER:-u,UintFromPhone
                PRIVATE LINKER:-u,find_path_by_files
            )
        elseif(CMAKE_C_COMPILER_ID MATCHES AppleClang)
            target_link_options(libchewing
                PRIVATE LINKER:-exported_symbols_list,${CMAKE_SOURCE_DIR}/src/symbols-mach_o.map
                PRIVATE LINKER:-dead_strip
            )
        elseif(MSVC)
            target_link_options(libchewing
                PRIVATE /DEF:${CMAKE_SOURCE_DIR}/src/symbols-msvc.map
                PRIVATE /MACHINE:X64)
            set_target_properties(libchewing PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreadedDLL")
        endif()
    endif()
elseif(WITH_SQLITE3)
   target_link_libraries(libchewing PRIVATE ${SQLite3_LIBRARIES})
endif()

if(MSVC)
    set_target_properties(libchewing PROPERTIES
        OUTPUT_NAME chewing-msvc
    )
else()
    set_target_properties(libchewing PROPERTIES
        OUTPUT_NAME chewing
        SOVERSION 3
        VERSION 3.3.1
    )
endif()

install(FILES ${ALL_INC} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/chewing)
install(FILES ${PROJECT_BINARY_DIR}/chewing.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(TARGETS libchewing DESTINATION ${CMAKE_INSTALL_LIBDIR})


set(CPACK_PACKAGE_CHECKSUM SHA256)
set(CPACK_SOURCE_IGNORE_FILES "/out" "/\\\\..*")
set(CPACK_SOURCE_GENERATOR TXZ)
set(CPACK_SOURCE_PACKAGE_FILE_NAME libchewing-${CMAKE_PROJECT_VERSION})
include(CPack)

=== data/CMakeLists.txt ===
if(WITH_RUST)
    set(ALL_DATA
        ${DATA_BIN_DIR}/tsi.dat
        ${DATA_BIN_DIR}/word.dat
    )
else()
    set(ALL_DATA
        ${DATA_BIN_DIR}/dictionary.dat
        ${DATA_BIN_DIR}/index_tree.dat
    )
endif()

add_custom_target(data ALL DEPENDS ${ALL_DATA})

# We need to copy static data to binary tree when using out of tree build.
set(ALL_STATIC_DATA
    ${DATA_BIN_DIR}/pinyin.tab
    ${DATA_BIN_DIR}/swkb.dat
    ${DATA_BIN_DIR}/symbols.dat
)

add_custom_target(all_static_data
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/pinyin.tab ${DATA_BIN_DIR}/pinyin.tab
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/swkb.dat ${DATA_BIN_DIR}/swkb.dat
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${DATA_SRC_DIR}/symbols.dat ${DATA_BIN_DIR}/symbols.dat
)

# tools
set(ALL_TOOLS init_database)

if(NOT WITH_RUST)
    list(APPEND ALL_TOOLS dump_database)
    add_executable(init_database ${TOOLS_SRC_DIR}/init_database.c $<TARGET_OBJECTS:common>)
    add_executable(dump_database
        ${TOOLS_SRC_DIR}/dump_database.c
        $<TARGET_OBJECTS:common>
    )
endif()
set_target_properties(${ALL_TOOLS} PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${TOOLS_BIN_DIR}
        RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TOOLS_BIN_DIR}
        RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${TOOLS_BIN_DIR}
        RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TOOLS_BIN_DIR}
        RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${TOOLS_BIN_DIR}
)

# tools command
file(MAKE_DIRECTORY ${DATA_BIN_DIR})
if(WITH_RUST)
    set(DATA_COPYRIGHT "Copyright \\(c\\) 2022 libchewing Core Team")
    set(DATA_LICENSE "LGPL-2.1-or-later")
    set(DATA_VERSION ${LIBCHEWING_VERSION})
    add_custom_command(
        OUTPUT
            ${ALL_DATA}
        COMMAND init_database
            -c ${DATA_COPYRIGHT}
            -l ${DATA_LICENSE}
            -r ${DATA_VERSION}
            -t trie
            -n 內建詞庫
            ${DATA_SRC_DIR}/tsi.src tsi.dat
        COMMAND init_database
            -c ${DATA_COPYRIGHT}
            -l ${DATA_LICENSE}
            -r ${DATA_VERSION}
            -t trie
            -n 內建字庫
            ${DATA_SRC_DIR}/word.src word.dat
        DEPENDS
            ${ALL_TOOLS}
            ${DATA_SRC_DIR}/word.src
            ${DATA_SRC_DIR}/tsi.src
        WORKING_DIRECTORY ${DATA_BIN_DIR}
    )
else()
    add_custom_command(
        OUTPUT
            ${ALL_DATA}
        COMMAND init_database ${DATA_SRC_DIR}/phone.cin ${DATA_SRC_DIR}/tsi.src
        DEPENDS
            ${ALL_TOOLS}
            ${DATA_SRC_DIR}/phone.cin
            ${DATA_SRC_DIR}/tsi.src
        WORKING_DIRECTORY ${DATA_BIN_DIR}
    )
endif()

install(FILES ${ALL_DATA} DESTINATION ${CMAKE_INSTALL_DATADIR}/libchewing)
install(FILES ${ALL_STATIC_DATA} DESTINATION ${CMAKE_INSTALL_DATADIR}/libchewing)

=== doc/CMakeLists.txt ===
set(INFO_SRC ${PROJECT_SOURCE_DIR}/doc/libchewing.texi)
set(INFO_BIN ${PROJECT_BINARY_DIR}/doc/libchewing.info)

option(BUILD_INFO "Build info doc from texi source")

find_program(MAKEINFO makeinfo)
if (BUILD_INFO AND MAKEINFO)
    add_custom_command(
        OUTPUT
            ${INFO_BIN}
        COMMAND ${MAKEINFO} ${INFO_SRC} -o ${INFO_BIN} -I ${PROJECT_BINARY_DIR}/doc
        DEPENDS
            ${INFO_SRC}
    )
    add_custom_target(INFO ALL DEPENDS ${INFO_BIN})
    add_dependencies(check INFO)

    install(FILES ${INFO_BIN} TYPE INFO)
endif()

=== test/CMakeLists.txt ===
set(ALL_TESTCASES
    test-bopomofo
    test-config
    test-easy-symbol
    test-error-handling
    test-fullshape
    test-keyboard
    test-keyboardless
    test-logger
    test-path
    test-regression
    test-reset
    test-special-symbol
    test-struct-size
    test-symbol
    test-userphrase
    test-utf8
)
if (NOT WITH_RUST)
    list(APPEND ALL_TESTCASES
        test-key2pho
        test-mmap
    )
endif()
set(ALL_TESTTOOLS
    performance
    randkeystroke
    simulate
    stress
    testchewing
)

if(${CURSES_FOUND})
    set(ALL_TESTTOOLS ${ALL_TESTTOOLS} genkeystroke)
endif()


set(ALL_TESTS ${ALL_TESTCASES} ${ALL_TESTTOOLS})

foreach(target ${ALL_TESTCASES})
    add_test(
        NAME ${target}
        COMMAND ${TEST_BIN_DIR}/${target}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
endforeach()

if(USE_VALGRIND)
    find_program(VALGRIND valgrind)
    if(VALGRIND)
        foreach(target ${ALL_TESTCASES})
            add_test("valgrind-${target}" ${VALGRIND} --error-exitcode=255 --leak-check=full ${TEST_BIN_DIR}/${target})
        endforeach()
    endif()
endif()

foreach(target ${ALL_TESTS})
    add_executable(${target} ${TEST_SRC_DIR}/${target}.c)
    target_link_libraries(${target} testhelper)
    target_link_libraries(${target} libchewing)
    target_compile_definitions(${target} PRIVATE
        CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
        TEST_HASH_DIR=\"${TEST_BIN_DIR}\"
        TEST_DATA_DIR=\"${TEST_SRC_DIR}/data\"
        TESTDATA=\"${TEST_SRC_DIR}/default-test.txt\"
    )
    add_dependencies(${target} data all_static_data)
    add_dependencies(check ${target})
endforeach()

add_library(testhelper STATIC
    ${TEST_SRC_DIR}/testhelper.c
    $<TARGET_OBJECTS:common>
)
target_compile_definitions(testhelper PRIVATE
    CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
    TEST_HASH_DIR=\"${TEST_BIN_DIR}\"
    TEST_DATA_DIR=\"${TEST_SRC_DIR}/data\"
    TESTDATA=\"${TEST_SRC_DIR}/default-test.txt\"
)

set_target_properties(${ALL_TESTS} PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${TEST_BIN_DIR}
)

if (${CURSES_FOUND})
    target_link_libraries(genkeystroke ${CURSES_LIBRARIES})
endif()

set(ALL_STATIC_TEST stresstest.py)
foreach(target ${ALL_STATIC_TEST})
    add_custom_target(${target} ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${TEST_SRC_DIR}/${target} ${TEST_BIN_DIR}/${target}
    )
    add_dependencies(check ${target})
endforeach()

=== debian/changelog ===
libchewing (0.6.0-1build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:02:08 +0200

libchewing (0.6.0-1) unstable; urgency=medium

  * New upstream release.
  * d/control:
    * Bump Standards-Version to 4.6.2.
    * Update Build-Depends.
    * Add Rules-Requires-Root: no.
  * d/rules: Fix dh_auto_test.
  * d/copyright: Update copyright years.
  * d/upstream/metadata: Remove deprecated field.
  * d/watch: Fix watch file.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 27 Jan 2024 11:34:11 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libchewing
 Section: libs
 Priority: optional
-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
 Uploaders:
  Kan-Ru Chen (陳侃如) <koster@debian.org>,
  Andrew Lee (李健秋) <ajqlee@debian.org>,
@@ -9,13 +10,14 @@
  ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
+ cmake,
  libncurses-dev,
  libsqlite3-dev,
- pkg-config,
  texinfo,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/input-method-team/libchewing
 Vcs-Git: https://salsa.debian.org/input-method-team/libchewing.git
+Rules-Requires-Root: no
 Homepage: https://chewing.im
 
 Package: libchewing3

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk

export V=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_INFO=1

override_dh_auto_test:
	dh_auto_test -- -j1 ARGS+=-j1

override_dh_missing:
	rm -f debian/*/usr/lib/*/*.la
	rm -f debian/*/usr/share/info/*.info

=== debian/watch ===
version=4

# See https://davesteele.github.io/development/2015/05/02/debian-watch-file-format-for-signed-github-source-tars/ for GitHub workaround for releases page.

opts="downloadurlmangle=s/archive\/refs\/tags\/v@ANY_VERSION@(@ARCHIVE_EXT@)/releases\/download\/v$1\/@PACKAGE@-$1.tar.xz/,filenamemangle=s/v@ANY_VERSION@(@ARCHIVE_EXT@)/@PACKAGE@-$1.tar.xz/" \
https://github.com/chewing/@PACKAGE@/tags .*/v@ANY_VERSION@.tar.gz

## libchewing 0.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.21.0)
-project(libchewing)
-
-set(CMAKE_PROJECT_VERSION 0.6.0)
+project(libchewing LANGUAGES C)
+
+set(CMAKE_PROJECT_VERSION 0.7.0)
 set(LIBCHEWING_VERSION ${CMAKE_PROJECT_VERSION})
 set(PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
 set(LIBCHEWING_BINARY_VERSION 1.0.0)
@@ -12,6 +12,10 @@
 if(UNIX)
     set(CMAKE_C_FLAGS "-g -O2 -Wall -fPIC ${CMAKE_C_FLAGS}")
     add_compile_definitions(UNDER_POSIX PIC)
+endif()
+
+if(MSVC)
+    set(CMAKE_C_FLAGS "/utf-8 ${CMAKE_C_FLAGS}")
 endif()
 
 include(CheckCCompilerFlag)
@@ -91,15 +95,13 @@
     FetchContent_MakeAvailable(Corrosion)
 
     corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing CRATE_TYPES staticlib FEATURES capi)
-    corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing-tools)
+    corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_testhelper)
+    corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing-cli)
     add_compile_definitions(WITH_RUST)
-    if(CMAKE_BUILD_TYPE MATCHES Debug)
-        corrosion_set_features(chewing FEATURES test-tracing)
-    endif()
     if(WITH_SQLITE3)
         corrosion_set_features(chewing FEATURES sqlite)
-    endif()
-    corrosion_add_target_local_rustflags(chewing -Ccodegen-units=1)
+        corrosion_set_features(chewing_testhelper FEATURES sqlite)
+    endif()
     if(ENABLE_GCOV)
         corrosion_set_env_vars(chewing CARGO_INCREMENTAL=0)
         corrosion_add_target_local_rustflags(chewing -Cinstrument-coverage -Ccodegen-units=1 -Cinline-threshold=0 -Clink-dead-code -Coverflow-checks=off -Cpanic=abort)
@@ -161,8 +163,8 @@
 set(TOOLS_BIN_DIR ${PROJECT_BINARY_DIR}/src/tools)
 set(DATA_SRC_DIR ${PROJECT_SOURCE_DIR}/data)
 set(DATA_BIN_DIR ${PROJECT_BINARY_DIR}/data)
-set(TEST_SRC_DIR ${PROJECT_SOURCE_DIR}/test)
-set(TEST_BIN_DIR ${PROJECT_BINARY_DIR}/test)
+set(TEST_SRC_DIR ${PROJECT_SOURCE_DIR}/tests)
+set(TEST_BIN_DIR ${PROJECT_BINARY_DIR}/tests)
 
 include(GNUInstallDirs)
 
@@ -210,7 +212,7 @@
 endif()
 
 add_subdirectory(doc)
-add_subdirectory(test)
+add_subdirectory(tests)
 add_subdirectory(data)
 
 # library
@@ -288,6 +290,9 @@
 endif()
 
 if(WITH_RUST)
+    corrosion_set_env_vars(chewing
+        CHEWING_DATADIR=${CMAKE_INSTALL_FULL_DATADIR}/libchewing
+    )
     target_link_libraries(libchewing PRIVATE chewing)
     target_link_libraries(chewing INTERFACE ${SQLite3_LIBRARIES})
     if(BUILD_SHARED_LIBS)
@@ -335,7 +340,8 @@
 
 
 set(CPACK_PACKAGE_CHECKSUM SHA256)
-set(CPACK_SOURCE_IGNORE_FILES "/out" "/\\\\..*")
-set(CPACK_SOURCE_GENERATOR TXZ)
+set(CPACK_PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
+set(CPACK_SOURCE_IGNORE_FILES "/out" "/target" "/\\\\..*")
+set(CPACK_SOURCE_GENERATOR TZST)
 set(CPACK_SOURCE_PACKAGE_FILE_NAME libchewing-${CMAKE_PROJECT_VERSION})
 include(CPack)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -35,14 +35,14 @@
         ${TOOLS_SRC_DIR}/dump_database.c
         $<TARGET_OBJECTS:common>
     )
+    set_target_properties(${ALL_TOOLS} PROPERTIES
+            RUNTIME_OUTPUT_DIRECTORY ${TOOLS_BIN_DIR}
+            RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TOOLS_BIN_DIR}
+            RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${TOOLS_BIN_DIR}
+            RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TOOLS_BIN_DIR}
+            RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${TOOLS_BIN_DIR}
+    )
 endif()
-set_target_properties(${ALL_TOOLS} PROPERTIES
-        RUNTIME_OUTPUT_DIRECTORY ${TOOLS_BIN_DIR}
-        RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TOOLS_BIN_DIR}
-        RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${TOOLS_BIN_DIR}
-        RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TOOLS_BIN_DIR}
-        RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${TOOLS_BIN_DIR}
-)
 
 # tools command
 file(MAKE_DIRECTORY ${DATA_BIN_DIR})
@@ -53,14 +53,14 @@
     add_custom_command(
         OUTPUT
             ${ALL_DATA}
-        COMMAND init_database
+        COMMAND chewing-cli init-database
             -c ${DATA_COPYRIGHT}
             -l ${DATA_LICENSE}
             -r ${DATA_VERSION}
             -t trie
             -n 內建詞庫
             ${DATA_SRC_DIR}/tsi.src tsi.dat
-        COMMAND init_database
+        COMMAND chewing-cli init-database
             -c ${DATA_COPYRIGHT}
             -l ${DATA_LICENSE}
             -r ${DATA_VERSION}
@@ -68,7 +68,7 @@
             -n 內建字庫
             ${DATA_SRC_DIR}/word.src word.dat
         DEPENDS
-            ${ALL_TOOLS}
+            chewing-cli
             ${DATA_SRC_DIR}/word.src
             ${DATA_SRC_DIR}/tsi.src
         WORKING_DIRECTORY ${DATA_BIN_DIR}

=== tests/CMakeLists.txt ===
set(ALL_TESTCASES
    test-bopomofo
    test-config
    test-easy-symbol
    test-error-handling
    test-fullshape
    test-keyboard
    test-keyboardless
    test-logger
    test-path
    test-regression
    test-reset
    test-special-symbol
    test-struct-size
    test-symbol
    test-userphrase
    test-utf8
)
if(NOT WITH_RUST)
    list(APPEND ALL_TESTCASES
        test-key2pho
        test-mmap
    )
endif()
set(ALL_TESTTOOLS
    performance
    randkeystroke
    simulate
    stress
    testchewing
)

if(CURSES_FOUND)
    set(ALL_TESTTOOLS ${ALL_TESTTOOLS} genkeystroke)
endif()


set(ALL_TESTS ${ALL_TESTCASES} ${ALL_TESTTOOLS})

foreach(target ${ALL_TESTCASES})
    add_test(
        NAME ${target}
        COMMAND ${TEST_BIN_DIR}/${target}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
endforeach()

if(USE_VALGRIND)
    find_program(VALGRIND valgrind)
    if(VALGRIND)
        foreach(target ${ALL_TESTCASES})
            add_test("valgrind-${target}" ${VALGRIND} --error-exitcode=255 --leak-check=full ${TEST_BIN_DIR}/${target})
        endforeach()
    endif()
endif()

foreach(target ${ALL_TESTS})
    add_executable(${target} ${TEST_SRC_DIR}/${target}.c)
    target_link_libraries(${target} testhelper)
    if(WITH_RUST)
        target_link_libraries(${target} chewing_testhelper)
    endif(WITH_RUST)
    target_link_libraries(${target} libchewing)
    target_compile_definitions(${target} PRIVATE
        CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
        TEST_HASH_DIR=\"${TEST_BIN_DIR}\"
        TEST_DATA_DIR=\"${TEST_SRC_DIR}/data\"
        TESTDATA=\"${TEST_SRC_DIR}/default-test.txt\"
    )
    add_dependencies(${target} data all_static_data)
    add_dependencies(check ${target})
endforeach()

add_library(testhelper STATIC
    ${TEST_SRC_DIR}/testhelper.c
    $<TARGET_OBJECTS:common>
)
target_compile_definitions(testhelper PRIVATE
    CHEWING_DATA_PREFIX=\"${DATA_BIN_DIR}\"
    TEST_HASH_DIR=\"${TEST_BIN_DIR}\"
    TEST_DATA_DIR=\"${TEST_SRC_DIR}/data\"
    TESTDATA=\"${TEST_SRC_DIR}/default-test.txt\"
)

set_target_properties(${ALL_TESTS} PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TEST_BIN_DIR}
    RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${TEST_BIN_DIR}
)

if (CURSES_FOUND)
    target_include_directories(genkeystroke PRIVATE ${CURSES_INCLUDE_DIRS})
    target_link_libraries(genkeystroke ${CURSES_LIBRARIES})
endif()

set(ALL_STATIC_TEST stresstest.py)
foreach(target ${ALL_STATIC_TEST})
    add_custom_target(${target} ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${TEST_SRC_DIR}/${target} ${TEST_BIN_DIR}/${target}
    )
    add_dependencies(check ${target})
endforeach()

if(WITH_RUST)
add_test(NAME cargo-test COMMAND cargo test --features capi$<$<BOOL:${WITH_SQLITE3}>:,sqlite>)
endif()
